@import "vars.css";
@import "composition.css";

:root {
    --page-padding: var(--spacing-3xl);
    --reading-max-width: 700px;
}

/*** Tags ***/

body {
    display: flex;
    flex-direction: column;
    align-items: center;
    padding: 0px;
    color: var(--on-surface);
    background-color: var(--surface);
    background-image: radial-gradient(
        circle at 700% 430%,
        var(--primary-container),
        var(--surface)
    );
    background-repeat: no-repeat;
    background-position: bottom right;
    background-attachment: fixed;
    margin: var(--page-padding);
}

main {
    display: flex;
    flex-direction: column;
    gap: var(--spacing-xl);
    max-width: 1280px;
}

footer {
    margin-top: var(--spacing-2xl);
    max-width: 1280px;
}

a {
    text-decoration: none;
    color: var(--on-surface);
}
a:hover {
    text-decoration: underline;
    color: var(--primary);
}

/*** Classes ***/

.header {
    display: flex;
    flex-direction: column;
    gap: var(--spacing-md);
    max-width: var(--reading-max-width);
}

.content {
    display: flex;
    flex-direction: row;
    gap: var(--spacing-lg);
}

.challenge {
    display: flex;
    flex-direction: column;
    gap: var(--spacing-sm);
    max-width: var(--reading-max-width);
    flex: 3 1 0;
}

.role {
    display: flex;
    flex-direction: column;
    gap: var(--spacing-sm);
    max-width: var(--reading-max-width);
    flex: 2 1 0;
}

.details {
    display: flex;
    flex-direction: column;
    align-self: center;
    gap: inherit;
    max-width: var(--reading-max-width);
}

.details div {
    display: flex;
    flex-direction: column;
    gap: var(--spacing-xs);
}

.details div > span:nth-child(2) {
    color: var(--on-surface-variant);
}

.result {
    display: flex;
    flex-direction: column;
    background-color: var(--surface-container-high);
    border-radius: var(--spacing-md);
    padding: var(--spacing-xl);
    overflow: hidden;
    height: 688px;
}

.insights-decisions {
    display: grid;
    grid-template-columns: auto 1fr 1fr;
    grid-template-rows: repeat(2, auto);
    row-gap: 0;
    column-gap: var(--spacing-lg);
    margin-top: var(--spacing-lg);
    margin-bottom: var(--spacing-lg);
}

.sideways-lr {
    writing-mode: vertical-lr;
    writing-mode: sideways-lr;
    align-self: center;
}

.r1 {
    display: flex;
    grid-row-start: 1;
}

.r1 div {
    display: flex;
    flex-direction: column;
    gap: var(--spacing-sm);
    padding: var(--spacing-xl) var(--spacing-xl) 0 var(--spacing-lg);
    border-radius: var(--spacing-md) var(--spacing-md) 0 0;
    background-color: var(--surface-container);
    color: var(--on-surface-variant);
    width: 100%;
}

.r2 {
    display: flex;
    grid-row-start: 2;
    overflow: hidden;
}

.r2 div {
    display: flex;
    flex-direction: column;
    gap: var(--spacing-sm);
    padding: var(--spacing-xl) var(--spacing-lg);
    border-radius: 0 0 var(--spacing-md) var(--spacing-md);
    background-color: var(--surface-container);
    color: var(--on-surface-variant);

    margin: 0;
    padding: 0;
    overflow: hidden;
}

.test {
    width: 100%;
    height: 300px;
}

.r2 div video {
    width: 134%;
    object-fit: cover;
    margin: 0;
    transform: translate(-124px, -36px);
}

.insight-list {
    display: flex;
    flex-direction: row;
    gap: var(--spacing-md);
}

.insight-list div {
    display: flex;
    flex-direction: column;
    gap: var(--spacing-sm);
    padding: var(--spacing-xl) var(--spacing-lg);
    border-radius: var(--spacing-md);
    background-color: var(--surface-container);
    flex: 1 0 0;
    color: var(--on-surface-variant);
}

.insight-list div ul {
    margin: 0;
}

.design-decisions {
    display: flex;
    flex-direction: column;
    gap: var(--spacing-sm);
}

.decisions-list {
    display: flex;
    flex-direction: row;
    gap: var(--spacing-md);
}

.decisions-list div {
    display: flex;
    flex-direction: column;
    gap: var(--spacing-sm);
    padding: var(--spacing-md) var(--spacing-md) var(--spacing-lg)
        var(--spacing-lg);
    border-radius: var(--spacing-sm);
    background-color: var(--surface-container);
    flex: 1 0 0;
    color: var(--on-surface-variant);
}

.testemonials {
    display: flex;
    flex-direction: column;
    gap: var(--spacing-sm);
}

.testemonials-list {
    display: flex;
    flex-direction: row;
    gap: var(--spacing-md);
}

.testemonials-list div {
    display: flex;
    flex-direction: column;
    gap: var(--spacing-sm);
    padding: var(--spacing-lg) var(--spacing-xl);
    border-radius: var(--spacing-md);
    background-color: var(--surface-container);
    flex: 1 0 0;
    color: var(--on-surface-variant);
    height: fit-content;
}

.testemonials-list span {
    display: flex;
    flex-direction: row;
    align-self: flex-end;
    margin-top: var(--spacing-lg);
}

.video {
    width: 100%;
    height: auto;
    border-radius: var(--spacing-sm);
    margin-top: var(--spacing-xl);
}

.result-header {
    display: flex;
    flex-direction: column;
    gap: var(--spacing-xs);
    max-width: 420px;
}

.highlight {
    font-weight: bold;
    color: var(--tertiary);
}

/*** Result-1 ***/

.result-1 {
    height: auto;
}

.result-1 > img {
    transform: scale(1.4) translate(40px, -60px);
    height: auto;
}

/*** Result-2 ***/

.result-2 {
    align-items: center;
    height: auto;
    padding: var(--spacing-xl);
}

.result-2 > img {
    margin-top: var(--spacing-xl);
    width: 100%;
    border-radius: var(--spacing-md);
}

/*** Result-3 ***/

.result-3 {
    align-items: flex-end;
    height: 960px;
}

.result-3 > img {
    transform: scale(0.4) translate(6200px, -3000px);
}

.anchor-wrapper {
    position: relative;
    min-height: 100%;
    width: 100%;
    transition: all 300ms cubic-bezier(0.5, 0, 0, 1);
}

.anchor-wrapper:hover {
    transform: scale(1.4) translate(0, 30px);
}

.anchor {
    --border-thickness: 10px;

    display: flex;
    align-items: center;
    width: 100%;

    position: absolute;
    bottom: calc(
        (227px / 2) - (var(--spacing-xl) / 2 + var(--border-thickness))
    );
    left: calc(50% - (var(--spacing-xl) / 2 + var(--border-thickness)));
    /* left: calc(50% - (var(--spacing-3xl) / 2) - (var(--border-thickness) / 2)); */
    z-index: 100;
    width: var(--spacing-xl);
    height: var(--spacing-xl);
    background-color: var(--primary);
    border: solid var(--surface) var(--border-thickness);
    border-radius: var(--spacing-xl);
}

.anchor i {
    width: 100%;
    text-align: center;
    color: var(--on-primary);
}

.cases {
    display: flex;
    flex-direction: column;
    gap: var(--spacing-md);
    width: 663px;
}

.chips {
    display: flex;
    gap: var(--spacing-xs);
    padding: 0;
    margin: 0;
    transition: all 300ms cubic-bezier(0.5, 0, 0, 1);
}

.chips > li {
    list-style-type: none;
    padding: var(--spacing-xs) var(--spacing-smd);
    border-radius: var(--radius-sm);
    color: var(--on-tertiary-container);
    background-color: var(--tertiary-container);
}

.case {
    display: flex;
    flex-direction: column;
    gap: var(--spacing-md);
    border-radius: var(--radius-md);
    padding: var(--spacing-lg);
    background-color: var(--surface-container-low);
    height: calc(227px - calc(var(--spacing-lg) * 2));
    overflow: hidden;
    flex: 1 1 0;
}

.case-link:hover {
    text-decoration: none;
    color: var(--on-surface);
}

.case > span {
    transition: all 300ms cubic-bezier(0.5, 0, 0, 1);
}

.case:hover > .chips {
    transform: translate(0px, -90px);
}

.case:hover > span {
    transform: translate(
        0px,
        calc((var(--spacing-md) + var(--spacing-lg)) * -1)
    );
}

.next-case {
    display: flex;
    flex-direction: column;
    gap: var(--spacing-md);
}
.next-case section {
    display: flex;
    flex-direction: row;
    gap: var(--spacing-md);
    height: 227px;
}

/*** Case-1 ***/

.case-1:hover {
    --border-size: 2px;
    /* fixing padding to perfectly fit the border */
    padding: calc(var(--spacing-lg) - var(--border-size));
    border: var(--border-size) solid transparent;
    border-radius: var(--radius-md);
    background:
        linear-gradient(var(--surface-container), var(--surface-container))
            padding-box,
        linear-gradient(140deg, var(--primary), var(--surface)) border-box;
    cursor: pointer;
}

.case-1 > span {
    max-width: 312px;
}

.case-3 > span {
    max-width: 400px;
}

.case-1:hover > .iso-grid {
    transform: scale(0.2) translate(-6600px, -3500px) rotateX(30deg)
        rotateZ(-15deg) translateZ(0);
}

.iso-grid {
    display: grid;
    grid-template-columns: repeat(3, auto);
    grid-template-rows: repeat(2, auto);
    gap: var(--spacing-md);
    will-change: transform;
    transform: scale(0.18) translate(-7600px, -3700px) rotateX(30deg)
        rotateZ(-10deg) translateZ(0);
    transform-style: preserve-3d;
    transition: all 300ms cubic-bezier(0.5, 0, 0, 1);
    width: fit-content;
}

.iso-grid > img {
    height: var(--grid-item-height);
    image-rendering: auto;
    backface-visibility: hidden;
    filter: sepia(20%);
}

/*** Case-2 ***/

.case-2:hover {
    --border-size: 2px;
    /* fixing padding to perfectly fit the border */
    padding: calc(var(--spacing-lg) - var(--border-size));
    border: var(--border-size) solid transparent;
    border-radius: var(--radius-md);
    background:
        linear-gradient(var(--surface-container), var(--surface-container))
            padding-box,
        linear-gradient(180deg, var(--primary), var(--surface)) border-box;
    cursor: pointer;
}

.case-2 > span {
    max-width: 500px;
}

.case-3 > ul {
    margin-left: auto;
}
.case-3 > span {
    margin-left: auto;
    text-align: right;
}

.case-2 > img {
    transform: scale(0.9, 0.9) translate(-30px, 10px) rotateZ(2.5deg)
        translateZ(0);
    transform-style: preserve-3d;
    transition: all 300ms cubic-bezier(0.5, 0, 0, 1);
}

.case-2:hover > img {
    transform: scale(1, 1) translate(-10px, -20px) rotateZ(2.5deg);
}

/*** Case-3 ***/

.case-3 .iso-grid {
    display: grid;
    grid-template-columns: repeat(4, auto);
    grid-template-rows: repeat(2, auto);
    gap: var(--spacing-md);
    will-change: transform;
    /* transform: translate(300px, -40px) rotateX(30deg) rotateZ(-15deg)
        translateZ(0); */
    transform: scale(0.31) translate(-2000px, -1400px) rotateX(30deg)
        rotateZ(8deg) translateZ(0);
    transform-style: preserve-3d;
    transition: all 300ms cubic-bezier(0.5, 0, 0, 1);
    width: fit-content;
}

.case-3:hover > .iso-grid {
    transform: scale(0.36) translate(-1580px, -1230px) rotateX(30deg)
        rotateZ(5deg) translateZ(0);
}

.case-3:hover {
    --border-size: 2px;
    /* fixing padding to perfectly fit the border */
    padding: calc(var(--spacing-lg) - var(--border-size));
    border: var(--border-size) solid transparent;
    border-radius: var(--radius-md);
    background:
        linear-gradient(var(--surface-container), var(--surface-container))
            padding-box,
        linear-gradient(140deg, var(--primary), var(--surface)) border-box;
    cursor: pointer;
}

/*** Typography ***/
.title-xl {
    font-family: var(--font-family-title);
    font-style: normal;
    font-weight: 700;
    font-size: var(--font-size-3xl);
    line-height: var(--line-height-sm);
    color: var(--on-surface);
}

.title-md {
    font-family: var(--font-family-title);
    font-style: normal;
    font-weight: 500;
    font-size: var(--font-size-lg);
    color: var(--on-surface);
}

.title-sm {
    font-family: var(--font-family-title);
    font-style: normal;
    font-weight: 400;
    font-size: var(--font-size-md);
    color: var(--on-surface);
}

.body-sm {
    font-family: var(--font-family-body);
    font-style: normal;
    font-weight: 400;
    font-size: var(--font-size-sm);
}

.body-xs {
    font-family: var(--font-family-body);
    font-style: normal;
    font-weight: 500;
    font-size: var(--font-size-xs);
}

/*** Surfaces ***/

.bg-surface {
    background-color: var(--surface);
    color: var(--on-surface);
}

.bg-surface-highest {
    background-color: var(--surface-container-highest);
    color: var(--on-surface-variant);
}
